/***************************************************************************
                          guarddogview.cpp  -  description
                             -------------------
    begin                : Thu Feb 10 20:57:36 EST 2000
    copyright            : (C) 2000 by Simon Edwards
    email                : simon@simonzone.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

// include files for Qt
#include <qprinter.h>
#include <qpainter.h>

// application specific includes
#include "guarddogview.h"
#include "guarddogdoc.h"
#include "guarddog.h"

#define BOX_BORDER   4

///////////////////////////////////////////////////////////////////////////
GuardDogView::GuardDogView(QWidget *parent, const char *name) : QWidget(parent, name)
{
	int i,j,maxwidth;
	QCheckBox *newbox;
	ProtocolInfo *pinfo;
	bool sumode;
	
	updatinglock = false;
	
    vertbox = new KContainerLayout(this,0,KContainerLayout::Vertical,false,0,0,false);
    tabs = new KTabCtl(vertbox);

	generalmaster = new QWidget(tabs);
generalparent = generalmaster;
//	generalmaster =tabs;
	
//    generalparent = new KContainerLayout(generalmaster,0,
//	    KContainerLayout::Horizontal,
////	    KContainerLayout::Vertical,
//	    false,0,0,false);

//	generalparent->packStart(new QWidget(generalparent),true,true);
	
	generalbox = new KContainerLayout(generalparent,0,KContainerLayout::Vertical,false,0,0,false);
		// Spacer
	generalbox->packStart(new QWidget(generalbox),true,true);
		
		// Internet interface:
	internetinterfacebox = new KContainerLayout(generalbox,0,KContainerLayout::Horizontal,false,0,0,false);
		
    internetinterfacelabel = new QLabel(0,i18n("Internet connection: "),internetinterfacebox);
	internetinterfacelabel->setMinimumSize(internetinterfacelabel->sizeHint());
	internetinterfacebox->packStart(internetinterfacelabel);

    internetinterface = new KCombo(internetinterfacebox);
    internetinterface->insertItem(i18n("ppp0 - Dialup Interface 0"));
    internetinterface->insertItem(i18n("ppp1 - Dialup Interface 1"));
    internetinterface->insertItem(i18n("ppp2 - Dialup Interface 2"));
    internetinterface->insertItem(i18n("ppp3 - Dialup Interface 3"));
    internetinterface->insertItem(i18n("eth0 - Ethernet connection 0"));
    internetinterface->insertItem(i18n("eth1 - Ethernet connection 1"));
    internetinterface->insertItem(i18n("eth2 - Ethernet connection 2"));
    internetinterface->insertItem(i18n("eth3 - Ethernet connection 3"));
    internetinterface->insertItem(i18n("isdn0 - ISDN connection 0"));
    internetinterface->insertItem(i18n("isdn1 - ISDN connection 1"));
    internetinterface->insertItem(i18n("isdn2 - ISDN connection 2"));
    internetinterface->insertItem(i18n("isdn3 - ISDN connection 3"));
    internetinterface->setFixedSize(internetinterface->sizeHint());
    internetinterface->setMinimumSize(internetinterface->sizeHint());

	internetinterfacebox->packStart(internetinterface);
	internetinterfacebox->sizeToFit();
	generalbox->packStart(internetinterfacebox);
	connect(internetinterface,SIGNAL(activated(int)),SLOT(slotInterfaceBox(int)));
	
		// Packet blocking	
	blockbox = new KContainerLayout(generalbox,0,KContainerLayout::Horizontal,false,0,0,false);
		
	blocklabel = new QLabel(0,i18n("Packet blocking: "), blockbox);
	blocklabel->setMinimumSize(blocklabel->sizeHint());
	blockbox->packStart(blocklabel);
	
	blockcombo = new KCombo(blockbox);
    blockcombo->insertItem(i18n("DENY - do not notify source of block"));
    blockcombo->insertItem(i18n("REJECT - notify source of block"));
    blockcombo->setFixedSize(blockcombo->sizeHint());
    blockcombo->setMinimumSize(blockcombo->sizeHint());
	blockbox->packStart(blockcombo);
	
	connect(blockcombo,SIGNAL(activated(int)),getDocument(),SLOT(slotBlock(int)));
	generalbox->packStart(blockbox);
		
		// Log blocked packets.
	logblockedpacketscheckbox = new QCheckBox("Log blocked packets", generalbox,0);
	logblockedpacketscheckbox->setMinimumSize(logblockedpacketscheckbox->sizeHint());
	logblockedpacketscheckbox->setFixedHeight(logblockedpacketscheckbox->sizeHint().height());
	generalbox->packStart(logblockedpacketscheckbox);
	connect(logblockedpacketscheckbox,SIGNAL(toggled(bool)),getDocument(),SLOT(slotSetLogPackets(bool)));
    	
		// Allow Ping.
	allowpingcheckbox = new QCheckBox("Allow Ping Relies", generalbox,0);
	allowpingcheckbox->setMinimumSize(allowpingcheckbox->sizeHint());
	allowpingcheckbox->setFixedHeight(allowpingcheckbox->sizeHint().height());
	generalbox->packStart(allowpingcheckbox);
	connect(allowpingcheckbox,SIGNAL(toggled(bool)),getDocument(),SLOT(slotSetAllowPing(bool)));
		
		// Log ping.
	logpingcheckbox = new QCheckBox("Log Ping",generalbox,0);
	logpingcheckbox->setMinimumSize(logpingcheckbox->sizeHint());
	logpingcheckbox->setFixedHeight(logpingcheckbox->sizeHint().height());
	generalbox->packStart(logpingcheckbox);
	connect(logpingcheckbox,SIGNAL(toggled(bool)),getDocument(),SLOT(slotSetLogPing(bool)));
	generalbox->packStart(new QWidget(generalbox),true,true);

	
//generalbox->sizeToFit();
	
//	generalparent->packStart(generalbox);
//	generalparent->packStart(new QWidget(generalparent),true,true);
//generalparent->sizeToFit();
	
		// -----------------
		// This widget holds the V layout for the client tab.
    clientgeneralparent = new QWidget(tabs);
	clientgenerallayout = new QHBoxLayout(clientgeneralparent);
	clientgenerallayout->addSpacing(2*BOX_BORDER);
    clientvbox = new KContainerLayout(clientgeneralparent,0,KContainerLayout::Vertical,false,BOX_BORDER,0,false);
	clientgenerallayout->addWidget(clientvbox);
			
				// Label
    clientlabel = new QLabel(0,i18n("Permitted Outgoing Client Protocols:"),clientvbox);
    clientlabel->setMinimumSize(clientlabel->sizeHint());
	clientlabel->setFixedHeight(clientlabel->sizeHint().height());
    clientvbox->packStart(clientlabel);
	clientscrollview = new QScrollView(clientvbox);
	clientscrollview->viewport()->setBackgroundColor(kapp->backgroundColor);
		// Grab a local ptr to the protocol database.
	pdb = ((GuardDogApp *)parentWidget())->pdb;
		// Build our big ass list of client protocol checkboxes.
	j = pdb->clientsList.count();
	clientlistvbox = new KContainerLayout(0,0,KContainerLayout::Vertical,false,0,0,false);
	if(j!=0) {	// This should always be !0.
		maxwidth = 0;
		for(pinfo = pdb->clientsList.first(),i=BOX_BORDER; pinfo!=0; pinfo = pdb->clientsList.next()) {
   		    // Add all the client protocols.
			newbox = new QCheckBox(pinfo->description,clientlistvbox,0); //->viewport(),0);
   			clientCheckBoxes.append(newbox);
			newbox->setMinimumSize(newbox->sizeHint());
			j = newbox->sizeHint().height();
			newbox->setFixedHeight(j);
			connect(newbox,SIGNAL(toggled(bool)),this,SLOT(slotProtocolBox(bool)));
			clientlistvbox->packStart(newbox);
		}
		clientlistvbox->sizeToFit();
		clientscrollview->addChild(clientlistvbox);
//		QSize qs = clientlistvbox->size();
//		clientscrollview->resizeContents(qs.width()*2,qs.height());
	}
	clientgenerallayout->addSpacing(2*BOX_BORDER);	
	clientscrollview->setFrameStyle(QFrame::Panel|QFrame::Sunken);
	clientvbox->packStart(clientscrollview,true,true,1);

		// -----------------
		// This widget holds the V layout for the server tab.
    servergeneralparent = new QWidget(tabs);
	servergenerallayout = new QHBoxLayout(servergeneralparent);
	servergenerallayout->addSpacing(2*BOX_BORDER);
    servervbox = new KContainerLayout(servergeneralparent,0,KContainerLayout::Vertical,false,BOX_BORDER,0,false);
	servergenerallayout->addWidget(servervbox);

				// Label
    serverlabel = new QLabel(0,i18n("Permitted Incoming Server Protocols:"),servervbox);
    serverlabel->setMinimumSize(serverlabel->sizeHint());
	serverlabel->setFixedHeight(serverlabel->sizeHint().height());
    servervbox->packStart(serverlabel);
	serverscrollview = new QScrollView(servervbox);
	serverscrollview->viewport()->setBackgroundColor(kapp->backgroundColor);
		// Build our big ass list of client protocol checkboxes.
	j = pdb->serversList.count();
	serverlistvbox = new KContainerLayout(0,0,KContainerLayout::Vertical,false,0,0,false);
	if(j!=0) {	// This should always be !0.
		maxwidth = 0;
		for(pinfo = pdb->serversList.first(),i=BOX_BORDER; pinfo!=0; pinfo = pdb->serversList.next()) {
   		    // Add all the client protocols.
			newbox = new QCheckBox(pinfo->description,serverlistvbox,0);
   			serverCheckBoxes.append(newbox);
			j = newbox->sizeHint().height();
			newbox->setFixedHeight(j);
			connect(newbox,SIGNAL(toggled(bool)),this,SLOT(slotProtocolBox(bool)));
			serverlistvbox->packStart(newbox);
		}
		serverlistvbox->sizeToFit();
		serverscrollview->addChild(serverlistvbox);
	}
	servergenerallayout->addSpacing(2*BOX_BORDER);	
	serverscrollview->setFrameStyle(QFrame::Panel|QFrame::Sunken);
	servervbox->packStart(serverscrollview,true,true,1);

    tabs->addTab(generalparent,i18n("General"));
    tabs->addTab(clientgeneralparent,i18n("Client Protocols"));
    tabs->addTab(servergeneralparent,i18n("Server Protocols"));
    vertbox->packStart(tabs,true,true);
  
        // The buttons at the bottom of the screen.
    buttonbox = new KContainerLayout(vertbox,0,KContainerLayout::Horizontal,true,0,0,false);

	sumode = ((GuardDogApp *)parentWidget())->sumode;
		
		// Ok button.
    okbutton = new QPushButton(i18n("Ok"),buttonbox,"Ok");
    okbutton->setMinimumSize(okbutton->sizeHint());
    if(!sumode) {
    	okbutton->setEnabled(false);
    }
	connect(okbutton,SIGNAL(clicked()),parentWidget(),SLOT(slotOk()));
	buttonbox->packStart(okbutton,true,true);
		
		// Apply button
    applybutton = new QPushButton(i18n("Apply"),buttonbox,"Apply");
    applybutton->setMinimumSize(applybutton->sizeHint());
	if(!sumode) {
		applybutton->setEnabled(false);
	}
	buttonbox->packStart(applybutton,true,true);
	connect(applybutton,SIGNAL(clicked()),parentWidget(),SLOT(slotApply()));
	
    quitbutton = new QPushButton(i18n("Exit"),buttonbox,"Exit");
    quitbutton->setMinimumSize(quitbutton->sizeHint());
	buttonbox->packStart(quitbutton,true,true);
	connect(quitbutton,SIGNAL(clicked()),parentWidget(),SLOT(slotFileQuit()));
	buttonbox->sizeToFit();
    vertbox->packStart(buttonbox,false,false);
    vertbox->sizeToFit();
//	generalgrid->activate();
}

///////////////////////////////////////////////////////////////////////////
GuardDogView::~GuardDogView()
{
}

///////////////////////////////////////////////////////////////////////////
void GuardDogView::buildCheckList(QList<ProtocolInfo> &protocols) {

}

///////////////////////////////////////////////////////////////////////////
GuardDogDoc *GuardDogView::getDocument() const
{
  GuardDogApp *theApp=(GuardDogApp *) parentWidget();

  return theApp->getDocument();
}

///////////////////////////////////////////////////////////////////////////
void GuardDogView::print(QPrinter *pPrinter)
{
  QPainter printpainter;
  printpainter.begin(pPrinter);
	
  // TODO: add your printing code here

  printpainter.end();
}

///////////////////////////////////////////////////////////////////////////
void GuardDogView::slotProtocolBox(bool on) {
	GuardDogDoc *doc;
	int i;
	QCheckBox *box;

	if(updatinglock) return;
	
	doc = getDocument();
		
		// Update the state of the Doc client protocol list.
	for(i=0,box=clientCheckBoxes.first(); box!=0; i++,box=clientCheckBoxes.next()) {
		doc->setClientProtocol(i,box->isChecked());
	}	

		// Now for Server.
	for(i=0,box=serverCheckBoxes.first(); box!=0; i++,box=serverCheckBoxes.next()) {
		doc->setServerProtocol(i,box->isChecked());
	}	
}

///////////////////////////////////////////////////////////////////////////
void GuardDogView::slotInterfaceBox(int index) {
	GuardDogDoc *doc;
	
	if(updatinglock) return;

	doc = getDocument();
	switch(index) {
		case 0:
			doc->setInterfaceName("ppp0");
			break;
		case 1:
			doc->setInterfaceName("ppp1");
			break;
		case 2:
			doc->setInterfaceName("ppp2");
			break;
		case 3:
			doc->setInterfaceName("ppp3");
			break;
		case 4:
			doc->setInterfaceName("eth0");
			break;
		case 5:
			doc->setInterfaceName("eth1");
			break;
		case 6:
			doc->setInterfaceName("eth2");
			break;
		case 7:
			doc->setInterfaceName("eth3");
			break;
		default:
			break;
	}
}
	
///////////////////////////////////////////////////////////////////////////
void GuardDogView::paintEvent(QPaintEvent *event) {
	GuardDogDoc *doc;
	int i;
	static char *interfaces[] = {"ppp0","ppp1","ppp2","ppp3","eth0","eth1","eth2","eth3"};
	QCheckBox *box;	
	doc = getDocument();
	char ifbuf[INTERFACE_NAME_LENGTH];
	
	updatinglock = true;

	doc->getInterfaceName(ifbuf);
	for(i=0; i<8; i++) {
		if(strcmp(ifbuf,interfaces[i])==0) {
			internetinterface->setCurrentItem(i);
			break;
		}
	}

		// Update some of the checkboxes.
	allowpingcheckbox->setChecked(doc->getAllowPing());
	logpingcheckbox->setChecked(doc->getLogPing());
	logblockedpacketscheckbox->setChecked(doc->getLogPackets());
	
		// Update the reply combo.
	if(doc->getReplyAction()==GuardDogDoc::REPLY_ACTION_DENY) {
		blockcombo->setCurrentItem(0);
	} else {
		blockcombo->setCurrentItem(1);	
	}

	
		// Update the state of the client protocols list.
	for(i=0; i < (int)clientCheckBoxes.count(); i++) {
		box = clientCheckBoxes.at(i);
		box->setChecked(doc->getClientProtocol(i));
	}	
	
		// Update the state of the server protocols list.
	for(i=0; i < (int)serverCheckBoxes.count(); i++) {
		box = serverCheckBoxes.at(i);
		box->setChecked(doc->getServerProtocol(i));
	}	
	updatinglock = false;	
}
