/***************************************************************************
                          guarddogview.h  -  description
                             -------------------
    begin                : Thu Feb 10 20:57:36 EST 2000
    copyright            : (C) 2000 by Simon Edwards
    email                : simon@simonzone.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef GUARDDOGVIEW_H
#define GUARDDOGVIEW_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif 

// include files for Qt
#include <qwidget.h>
#include <ktabctl.h>
#include <qpushbutton.h>
#include <qscrollbar.h>
#include <qscrollview.h>
#include <qlabel.h>
#include <qcheckbox.h>
#include <qlayout.h>
#include <kcontainer.h>
#include <kcombo.h>
#include <qlist.h>

#include "protocoldb.h"
#include "protocolinfo.h"

class GuardDogDoc;

/** The GuardDogView class provides the view widget for the GuardDogApp instance.	
 * The View instance inherits QWidget as a base class and represents the view object of a KTMainWindow. As GuardDogView is part of the
 * docuement-view model, it needs a reference to the document object connected with it by the GuardDogApp class to manipulate and display
 * the document structure provided by the GuardDogDoc class.
 * 	
 * @author Source Framework Automatically Generated by KDevelop, (c) The KDevelop Team.
 * @version KDevelop version 0.4 code generation
 */
class GuardDogView : public QWidget
{
Q_OBJECT
public:
    /** Constructor for the main view */
    GuardDogView(QWidget *parent = 0, const char *name=0);
    /** Destructor for the main view */
    ~GuardDogView();

    /** returns a pointer to the document connected to the view instance. Mind that this method requires a GuardDogApp instance as a parent
     * widget to get to the window document pointer by calling the GuardDogApp::getDocument() method.
     *
     * @see GuardDogApp#getDocument
     */
    GuardDogDoc *getDocument() const;

    /** contains the implementation for printing functionality */
    void print(QPrinter *pPrinter);

public slots:
	void slotProtocolBox(bool on);	
    void slotInterfaceBox(int index);
	
private:
    void buildCheckList(QList<ProtocolInfo> &protocols);
	virtual void paintEvent(QPaintEvent *event);
	
	bool updatinglock;
    KContainerLayout *buttonbox;
    KContainerLayout *vertbox;
    
    KTabCtl *tabs;

    QPushButton *okbutton;
    QPushButton *applybutton;	
    QPushButton *quitbutton;
        
	QWidget *generalmaster;
	KContainerLayout *generalbox;
//    KContainerLayout *generalparent;
QWidget *generalparent;

    QPushButton *general;	

	KContainerLayout *internetinterfacebox;
    QLabel *internetinterfacelabel;
    KCombo *internetinterface;
	
	KContainerLayout *blockbox;
	QLabel *blocklabel;
	KCombo *blockcombo;
	
	QCheckBox *allowpingcheckbox;
	QCheckBox *logpingcheckbox;
	QCheckBox *logblockedpacketscheckbox;
	
//	QGridLayout *generalgrid;
	
	ProtocolDB *pdb;

    QWidget *clientparent;
    QLabel *clientlabel;
	QWidget *clientgeneralparent;
	QHBoxLayout *clientgenerallayout;
    KContainerLayout *clientvbox;
	QList<QCheckBox> clientCheckBoxes;
	QScrollView *clientscrollview;
    KContainerLayout *clientlistvbox;
		
    QWidget *serverparent;
    QLabel *serverlabel;
	QWidget *servergeneralparent;
	QHBoxLayout *servergenerallayout;
    KContainerLayout *servervbox;
	QList<QCheckBox> serverCheckBoxes;
	QScrollView *serverscrollview;
    KContainerLayout *serverlistvbox;
};

#endif // GUARDDOGVIEW_H
