/***************************************************************************
                          protocolinfo.h  -  description
                             -------------------
    begin                : Thu Feb 10 2000
    copyright            : (C) 2000 by Simon Edwards
    email                : simon@simonzone.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef PROTOCOLINFO_H
#define PROTOCOLINFO_H

#include <qglobal.h>
#include "stringparse.h"

/**
  *@author Simon Edwards
  */
  
class ProtocolInfo {
public: 
	ProtocolInfo();
	~ProtocolInfo();
    bool parseLine(StringParse &parser);
    
    char *name;
    char *description;
    
    class PortSpec {
    	public:
    	PortSpec() {};
        PortSpec *next;
        uint portStart;
        uint portEnd;
    };
    struct PortSpec *allowInTCP;
    struct PortSpec *allowInTCPSource;
    struct PortSpec *allowOutTCP;
    struct PortSpec *allowOutTCPSource;

    struct PortSpec *allowInUDP;
    struct PortSpec *allowInUDPSource;
    struct PortSpec *allowOutUDP;
    struct PortSpec *allowOutUDPSource;

protected:
    void destroyPortSpec(struct PortSpec *x);
    bool parsePortSpec(StringParse &parser,struct PortSpec **x);
    
};

#endif
